// If this code works, it was written by Svetlio Kapralov. If not, I don't know who wrote it.
package net.playerfinder.jsf.components.common;

import java.util.List;
import java.util.Map;

import javax.faces.component.UIComponent;
import javax.faces.component.behavior.ClientBehavior;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

public class Utils {

	public static String escapeIdForJQuery(String id) {
		String jQueryId = id.replace(":", "\\\\:");
		return jQueryId;
	}

	public static void decodeBehaviors(FacesContext context,
			UIComponent component) {

		if (!(component instanceof ClientBehaviorHolder)) {
			return;
		}

		Map<String, List<ClientBehavior>> behaviors = ((ClientBehaviorHolder) component)
				.getClientBehaviors();
		if (behaviors.isEmpty()) {
			return;
		}

		String clientId = component.getClientId();

		ExternalContext external = context.getExternalContext();
		Map<String, String> params = external.getRequestParameterMap();
		String behaviorEvent = params.get("javax.faces.behavior.event");

		if (behaviorEvent != null) {
			List<ClientBehavior> behaviorsForEvent = behaviors
					.get(behaviorEvent);

			if (behaviors.size() > 0) {
				String behaviorSource = params.get("javax.faces.source");
				if (behaviorSource != null && behaviorSource.equals(clientId)) {
					for (ClientBehavior behavior : behaviorsForEvent) {
						behavior.decode(context, component);
					}
				}
			}
		}
	}

}
